/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Jul 22, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.security.SecAsn1Coder;

import dstep.security.SecAsn1Types;
import dstep.security.SecBase;
import dstep.security.cssmtype;
//import dstep.sys.types;

struct SecAsn1Coder;

alias SecAsn1Coder* SecAsn1CoderRef;

extern (C)
{
	int SecAsn1CoderCreate (SecAsn1CoderRef* coder);
	int SecAsn1CoderRelease (SecAsn1CoderRef coder);
	int SecAsn1Decode (SecAsn1CoderRef coder, void* src, uint len, SecAsn1Template* templates, void* dest);
	int SecAsn1DecodeData (SecAsn1CoderRef coder, CSSM_DATA* src, SecAsn1Template* templ, void* dest);
	int SecAsn1EncodeItem (SecAsn1CoderRef coder, void* src, SecAsn1Template* templates, CSSM_DATA* dest);
	void* SecAsn1Malloc (SecAsn1CoderRef coder, uint len);
	int SecAsn1AllocItem (SecAsn1CoderRef coder, CSSM_DATA* item, uint len);
	int SecAsn1AllocCopy (SecAsn1CoderRef coder, void* src, uint len, CSSM_DATA* dest);
	int SecAsn1AllocCopyItem (SecAsn1CoderRef coder, CSSM_DATA* src, CSSM_DATA* dest);
}